//
//  SFRecordable.h
//  Sketch
//
//  Created by doster on 12/15/05.
//  Copyright 2005 Apple Computer, Inc. All rights reserved.
// See the .m file for significant comments
// Some modifications by David Phillip Oster. You may use those modifications freely, provided that just
// as you hold Apple blameless, you must also hold me blameless. Feb 2006 <mailto:oster@ieee.org>


#import <Cocoa/Cocoa.h>

@interface SFRecordingManager : NSObject 
{
  @private
	BOOL mIsRecording;
}

+ (SFRecordingManager*) sharedInstance;

- (void) finishLaunching;	// apps should call this from applicationDidFinishLaunching to install handlers.

- (BOOL) isRecording;

- (void) recordSet: (id) directObj property: (NSString*) propertyName to: (id) value;

- (void) recordCreate: (id) createdObj;
- (void) recordIndex: (id) directObj;

- (void) recordBounds: (id) directObj;
- (void) recordDelete: (id) directObj;
- (void) recordPosition: (id) directObj;
- (void) recordSize: (id) directObj;
@end

// By analogy with NSUndoManager, many model/view objects can have a method to get the recording manager.
// Most just return the global shared instance.
@protocol SFRecordable < NSObject >

- (SFRecordingManager*) recordingManager;

@end


